Package org.springframework.cglib.transform

# Class AnnotationVisitorTee

java.lang.Object
org.springframework.asm.AnnotationVisitor
org.springframework.cglib.transform.AnnotationVisitorTee

public class AnnotationVisitorTee extends AnnotationVisitor

## Field Summary

### Fields inherited from class org.springframework.asm.AnnotationVisitor

`api, av`

## Constructor Summary

Constructors
Constructor
Description
`AnnotationVisitorTee(AnnotationVisitor av1, AnnotationVisitor av2)`

## Method Summary

Modifier and Type
Method
Description
`static AnnotationVisitor`
`getInstance(AnnotationVisitor av1, AnnotationVisitor av2)`
`void`
`visit(String name, Object value)`
Visits a primitive value of the annotation.
`AnnotationVisitor`
`visitAnnotation(String name, String desc)`
Visits a nested annotation value of the annotation.
`AnnotationVisitor`
`visitArray(String name)`
Visits an array value of the annotation.
`void`
`visitEnd()`
Visits the end of the annotation.
`void`
`visitEnum(String name, String desc, String value)`
Visits an enumeration value of the annotation.

### Methods inherited from class org.springframework.asm.AnnotationVisitor

`getDelegate`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### AnnotationVisitorTee

public AnnotationVisitorTee(AnnotationVisitor av1, AnnotationVisitor av2)

## Method Details

### getInstance

public static AnnotationVisitor getInstance(AnnotationVisitor av1, AnnotationVisitor av2)

### visit

public void visit(String name, Object value)
Description copied from class: `AnnotationVisitor`
Visits a primitive value of the annotation.

Overrides:
  `visit` in class `AnnotationVisitor`
Parameters:
  `name` - the value name.
  `value` - the actual value, whose type must be `Byte`, `Boolean`, `Character`, `Short`, `Integer` , `Long`, `Float`, `Double`, `String` or `Type` of `Type.OBJECT` or `Type.ARRAY` sort. This value can also be an array of byte, boolean, short, char, int, long, float or double values (this is equivalent to using `AnnotationVisitor.visitArray(java.lang.String)` and visiting each array element in turn, but is more convenient).

### visitEnum

public void visitEnum(String name, String desc, String value)
Description copied from class: `AnnotationVisitor`
Visits an enumeration value of the annotation.

Overrides:
  `visitEnum` in class `AnnotationVisitor`
Parameters:
  `name` - the value name.
  `desc` - the class descriptor of the enumeration class.
  `value` - the actual enumeration value.

### visitAnnotation

public AnnotationVisitor visitAnnotation(String name, String desc)
Description copied from class: `AnnotationVisitor`
Visits a nested annotation value of the annotation.

Overrides:
  `visitAnnotation` in class `AnnotationVisitor`
Parameters:
  `name` - the value name.
  `desc` - the class descriptor of the nested annotation class.
Returns:
  a visitor to visit the actual nested annotation value, or null if this visitor is not interested in visiting this nested annotation. The nested annotation value must be fully visited before calling other methods on this annotation visitor.

### visitArray

public AnnotationVisitor visitArray(String name)
Description copied from class: `AnnotationVisitor`
Visits an array value of the annotation. Note that arrays of primitive values (such as byte, boolean, short, char, int, long, float or double) can be passed as value to `visit`. This is what `ClassReader` does for non empty arrays of primitive values.

Overrides:
  `visitArray` in class `AnnotationVisitor`
Parameters:
  `name` - the value name.
Returns:
  a visitor to visit the actual array value elements, or null if this visitor is not interested in visiting these values. The 'name' parameters passed to the methods of this visitor are ignored. All the array values must be visited before calling other methods on this annotation visitor.

### visitEnd

public void visitEnd()
Description copied from class: `AnnotationVisitor`
Visits the end of the annotation.

Overrides:
  `visitEnd` in class `AnnotationVisitor`